// // // // // // // // // // // // // // //
// movieclip.plot()                       //
// version 0.4b - 2005/02/02              //
// -------------------------------------- //
// copyright:                             //
// - martinvoegeli@gmx.ch                 //
// -------------------------------------- //
// the lates version can be found here:   //
// - http://birdy1976.com/flash/plotter/  //
// -------------------------------------- //
// non commercial: free use               //
// commercial: contact me                 //
// -------------------------------------- //
// if you improve the script              //
// please send me the code!               //
// // // // // // // // // // // // // // //
//
// change log:
// version 0.4b - 2005/02/02
// - some "arrx" and "arry" replaced by "arrX" and "arrY"
// version 0.4 - 2003/08/03
// 
// // // // // // // // // // // // // // //
//
// general usage:
// #include "plot.as"
// mc.plot(arg1, arg2[, style])
// 
// style:
// var style = new Array(weight[, color[, alpha[, marker]]])
// - weight: weigth of the graph (1 to 10 pixel)
// - color:  color of the graph as a rgb hex value (e.g. red = 0xff0000)
// - alpha:  alpha value of the graph (0 = invisible; 100 = solid)
// - marker: "+" for +, "x" for x, "s" for square, "d" for diamond
// 
// use case 1 (matrix):
// var arrX = new Array(0,1,2,3,4,5,6,7,8,9);
// var arrY = new Array(0,1,2,3,4,5,6,7,8,9);
// mc.plot(arrX, arrY);
// 
// use case 2 (function):
// function func(x){
//   return Math.sin(x)*4;
// }
// mc.plot(func, [0, 6.3]);
// 
// use case 3 (plotter):
// var xmin = 0; var xmax =  5;
// var ymin = 0; var ymax = 25;
// mc.setAxisRange(xmin, xmax, ymin, ymax);
// for(var i = xmin; i <= xmax; i++){
//   mc.plot(i, Math.pow(i,2), [1, 0xff0000, 100, "x"]);
// }
// 
Array.prototype.min = function() {
    var floatMin = parseFloat(this[0]);
    for (var i = 1; i<this.length; i++) {
        floatMin = Math.min(floatMin, parseFloat(this[i]));
    }
    return floatMin;
};
Array.prototype.max = function() {
    var floatMax = parseFloat(this[0]);
    for (var i = 1; i<this.length; i++) {
        floatMax = Math.max(floatMax, parseFloat(this[i]));
    }
    return floatMax;
};
// you may change this properties (before plotting)...
// remark: p = plot and div = division
MovieClip.prototype._pwidth = new Number(300);
MovieClip.prototype._pheight = new Number(240);
MovieClip.prototype._pxdiv = new Number(10);
MovieClip.prototype._pydiv = new Number(10);
MovieClip.prototype._pxlabel = new Boolean(true);
MovieClip.prototype._pylabel = new Boolean(true);
MovieClip.prototype._phold = new Boolean(true);
MovieClip.prototype._pborder = new Boolean(true);
MovieClip.prototype._pgrid = new Boolean(true);
MovieClip.prototype._plinestyle = new Array(1, 0x0000ff, 100, "");
MovieClip.prototype._pborderstyle = new Array(1, 0x000000, 100);
MovieClip.prototype._pgridstyle = new Array(1, 0xdddddd, 100);
// ... but not these ones:
MovieClip.prototype._pxmin = new Number(0);
MovieClip.prototype._pxmax = new Number(50);
MovieClip.prototype._pymin = new Number(0);
MovieClip.prototype._pymax = new Number(50);
MovieClip.prototype._pfirst = new Boolean(true);
MovieClip.prototype._pxhold = new Boolean(false);
MovieClip.prototype._pyhold = new Boolean(false);
// 
MovieClip.prototype.clearPlot = function() {
    this.clear();
    for (i in this) {
        if (typeof (i) == "string") {
            this[i].text = "";
        }
    }
    this._pfirst = true;
};
// 
// DRAW FUNCTIONS
// 
MovieClip.prototype.drawBorder = function() {
    this.lineStyle(this._pborderstyle[0], this._pborderstyle[1], this._pborderstyle[2]);
    this.moveTo(0, 0);
    this.lineTo(this._pwidth, 0);
    this.lineTo(this._pwidth, this._pheight);
    this.lineTo(0, this._pheight);
    this.lineTo(0, 0);
    var textFormat = new TextFormat();
    textFormat.font = "Tahoma";
    textFormat.size = 9;
    textFormat.color = 0x000000;
    textFormat.align = "center";
    var intLabelWidth = 50;
    var intLabelHeight = 15;
    var intPixX = this._pwidth/this._pxdiv;
    for (var i = 0; i<=this._pxdiv; i++) {
        if (this._pxlabel) {
            var strName = "xLabel"+i;
            this.createTextField(strName, i+100, intPixX*i-intLabelWidth/2, this._pheight+(1-i%2)*intLabelHeight, intLabelWidth, intLabelHeight);
            this[strName].text = this.getAxisLabel(this._pxmin, this._pxmax, this._pxdiv, i);
            this[strName].setTextFormat(textFormat);
        }
        this.moveTo(Math.round(intPixX*i), 0);
        this.lineTo(Math.round(intPixX*i), 5);
        this.moveTo(Math.round(intPixX*i), this._pheight);
        this.lineTo(Math.round(intPixX*i), this._pheight-5);
    }
    textFormat.align = "right";
    var intPixY = this._pheight/this._pydiv;
    for (var i = 0; i<=this._pydiv; i++) {
        if (this._pylabel) {
            var strName = "yLabel"+i;
            this.createTextField(strName, i+200, -intLabelWidth, intPixY*(this._pydiv-i)-intLabelHeight/2, intLabelWidth, intLabelHeight);
            this[strName].text = this.getAxisLabel(this._pymin, this._pymax, this._pydiv, i);
            this[strName].setTextFormat(textFormat);
        }
        this.moveTo(0, Math.round(intPixY*i));
        this.lineTo(5, Math.round(intPixY*i));
        this.moveTo(this._pwidth, Math.round(intPixY*i));
        this.lineTo(this._pwidth-5, Math.round(intPixY*i));
    }
};
// 
MovieClip.prototype.drawGrid = function() {
    var intPixX = this._pwidth/this._pxdiv;
    this.lineStyle(this._pgridstyle[0], this._pgridstyle[1], this._pgridstyle[2]);
    for (var i = 0; i<=this._pxdiv; i++) {
        this.moveTo(Math.round(intPixX*i), 0);
        this.lineTo(Math.round(intPixX*i), this._pheight);
    }
    var intPixY = this._pheight/this._pydiv;
    for (var i = 0; i<=this._pydiv; i++) {
        this.moveTo(0, Math.round(intPixY*i));
        this.lineTo(this._pwidth, Math.round(intPixY*i));
    }
};
// 
MovieClip.prototype.drawMarker = function(x, y, style) {
    this.lineStyle(style[0], style[1], style[2]);
    if (style[3] == "x") {
        var intLength = 4;
        this.moveTo(x+intLength, y+intLength);
        this.lineTo(x-intLength, y-intLength);
        this.moveTo(x+intLength, y-intLength);
        this.lineTo(x-intLength, y+intLength);
        this.moveTo(x, y);
    }
    if (style[3] == "+") {
        var intLength = 5;
        this.moveTo(x, y+intLength);
        this.lineTo(x, y-intLength);
        this.moveTo(x+intLength, y);
        this.lineTo(x-intLength, y);
        this.moveTo(x, y);
    }
    if (style[3] == "s") {
        var intLength = 2;
        this.moveTo(x+intLength, y+intLength+1);
        this.beginFill(style[1], style[2]);
        this.lineTo(x+intLength, y-intLength);
        this.lineTo(x-intLength, y-intLength);
        this.lineTo(x-intLength, y+intLength);
        this.lineTo(x+intLength, y+intLength);
        this.moveTo(x, y);
        this.endFill();
    }
    if (style[3] == "d") {
        var intLength = 3;
        x += 1;
        y += 0;
        this.moveTo(x, y+intLength);
        this.beginFill(style[1], style[2]);
        this.lineTo(x+intLength, y);
        this.lineTo(x, y-intLength);
        this.lineTo(x-intLength, y);
        this.lineTo(x, y+intLength);
        this.moveTo(x, y);
        this.endFill();
    }
};
// 
MovieClip.prototype.drawMatrix = function(arrX, arrY, style) {
    this.lineStyle(style[0], style[1], style[2]);
    for (var i = 0; i<Math.min(arrX.length, arrY.length)-1; i++) {
        var arrPixel0 = this.getPixel(arrX[i], arrY[i]);
        var arrPixel1 = this.getPixel(arrX[i+1], arrY[i+1]);
        this.moveTo(arrPixel0[0], arrPixel0[1]);
        this.drawMarker(arrPixel0[0], arrPixel0[1], style);
        this.lineTo(arrPixel1[0], arrPixel1[1]);
        this.drawMarker(arrPixel1[0], arrPixel1[1], style);
    }
    if (Math.min(arrX.length, arrY.length) == 1) {
        this.drawMarker(this.getPixel(arrX[0], arrY[0])[0], this.getPixel(arrX[0], arrY[0])[1], style);
    }
};
// 
// GET FUNCTIONS
// 
MovieClip.prototype.getAxisLabel = function(floatStart, floatEnd, intDivision, intNrOfLabel) {
    // calculate exact value for Label - floatStart always = 0 ???
    floatLabel = (floatEnd-floatStart);
    intExp = Math.floor(Math.log(Math.abs(floatLabel))/Math.LN10/3)*3;
    floatLabel = (floatStart+intNrOfLabel*floatLabel/intDivision)*Math.pow(10, -intExp);
    // return value with reestablished sign;
    if (intExp == 0) {
        return floatLabel;
    } else {
        if (floatLabel == 0) {
            return floatLabel;
        } else {
            return floatLabel+"10^"+intExp;
        }
    }
};
// 
MovieClip.prototype.getAxisRange = function(min, max, intDivision) {
    if (min > max) {
        var temp = min;
        min = max;
        max = temp;
    }
    if (min == 0 && max == 0) {
        min = -10;
        max = +10;
    }
    if (min == max) {
        min -= Math.abs(min)/2;
        max += Math.abs(max)/2;
    }
    var floatScale = (max-min)/intDivision;
    var intTempExponent = Math.floor(Math.log(floatScale)/Math.LN10);
    floatScale = floatScale*Math.pow(10, -intTempExponent);
    if (floatScale == 1) {
        floatScale = 1;
    } else if (floatScale<=1.5) {
        floatScale = 1.5;
    } else if (floatScale<=2) {
        floatScale = 2;
    } else if (floatScale<=2.5) {
        floatScale = 2.5;
    } else {
        floatScale = Math.ceil(floatScale);
    }
    var floatDivision = floatScale*Math.pow(10, intTempExponent);
    min = Math.round(min/floatDivision)*floatDivision;
    max = min+floatDivision*intDivision;
    return [min, max];
};
// 
MovieClip.prototype.getMatrix = function(formula, arrRange) {
    var intSteps = (arrRange[1]-arrRange[0])/this._pwidth;
    var arrX = new Array();
    var arrY = new Array();
    for (var i = 0; intSteps*i<=arrRange[1]-arrRange[0]; i++) {
        arrX[i] = arrRange[0]+intSteps*i;
        arrY[i] = formula(arrX[i]);
    }
    return [arrX, arrY];
};
// 
MovieClip.prototype.getPixel = function(x, y) {
    var intPixelX = Math.round((x-this._pxmin)*this._pwidth/(this._pxmax-this._pxmin));
    var intPixelY = Math.round((y-this._pymin)*this._pheight/(this._pymax-this._pymin)*(-1)+this._pheight);
    return [intPixelX, intPixelY];
};
// 
// SET FUNCTIONS
// 
MovieClip.prototype.setAxisRange = function(xmin, xmax, ymin, ymax) {
    this._pxmin = xmin;
    this._pxmax = xmax;
    this._pymin = ymin;
    this._pymax = ymax;
    // to do: single axis i.e. only x (or y)
    this._pxhold = true;
    this._pyhold = true;
};
// 
MovieClip.prototype.setDimension = function(width, height) {
    this._pwidth = width;
    this._pheight = height;
};
// 
MovieClip.prototype.setDivision = function(xDiv, yDiv) {
    this._pxdiv = xDiv;
    this._pydiv = yDiv;
};
// 
MovieClip.prototype.setXLabel = function(label) {
    var textFormat = new TextFormat();
    textFormat.font = "Tahoma";
    textFormat.size = 12;
    textFormat.align = "center";
    this.createTextField("xlabel", 1, 0, this._pheight+30, this._pwidth, 20);
    this.xLabel.embedFonts = true;
    this.xLabel.text = label;
    this.xLabel.setTextFormat(textFormat);
};
// 
MovieClip.prototype.setYLabel = function(label) {
    var textFormat = new TextFormat();
    textFormat.font = "Tahoma";
    textFormat.size = 12;
    textFormat.align = "center";
    this.createTextField("ylabel", 2, -55, this._pheight, this._pheight, 20);
    this.yLabel._rotation = -90;
    this.yLabel.embedFonts = true;
    this.yLabel.text = label;
    this.yLabel.setTextFormat(textFormat);
};
// 
// MAIN FUNCTION: MC.PLOT()
// 
MovieClip.prototype.plot = function(arg1, arg2, style) {
    if (typeof(arg1) == "function" && typeof(arg2[0]) == "number" && typeof(arg2[1]) == "number" && arg2[0] < arg2[1]) {
        var temp = this.getMatrix(arg1, arg2);
        arg1 = temp[0];
        arg2 = temp[1];
    }
    if (typeof(arg1) == "number" && typeof(arg2) == "number") {
        arg1 = [arg1];
        arg2 = [arg2];
    }
    if (typeof(style) != "object") {
        var style = new Array(this._plinestyle[0], this._plinestyle[1], this._plinestyle[2], this._plinestyle[3]);
    } else {
        style[0] = (typeof(style[0]!="number"))? this._plinestyle[0]: style[0];
        style[1] = (typeof(style[1]!="number"))? this._plinestyle[1]: style[1];
        style[2] = (typeof(style[2]!="number"))? this._plinestyle[2]: style[2];
        style[3] = (typeof(style[3]!="string"))? this._plinestyle[3]: style[3];
    }
    if (arg1.length == arg2.length) {
        if (this._pfirst) {
            if (this._pxhold == false) {
                var arrRangeX = getAxisRange(arg1.min(), arg1.max(), this._pxdiv);
            } else {
                var arrRangeX = [this._pxmin, this._pxmax];
            }
            if (this._pyhold == false) {
                var arrRangeY = getAxisRange(arg2.min(), arg2.max(), this._pydiv);
            } else {
                var arrRangeY = [this._pymin, this._pymax];
            }
            this.setAxisRange(arrRangeX[0], arrRangeX[1], arrRangeY[0], arrRangeY[1]);
            if (this._pgrid) {
                this.drawGrid();
            }
            if (this._pborder) {
                this.drawBorder();
            }
            this.drawMatrix(arg1, arg2, style);
            this._pfirst = false;
        } else {
            if (this._phold) {
                this.drawMatrix(arg1, arg2, style);
            }
        }
    } else {
        trace("Error! Check call of function plot()");
    }
};